Index: trunk/MagicSoft/Mars/mhist/HistLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 4430)
+++ trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 4463)
@@ -11,6 +11,4 @@
 #pragma link C++ class MHCamEvent+;
 #pragma link C++ class MHTriggerLvl0+;
-
-#pragma link C++ class MHBlindPixels+;
 
 #pragma link C++ class MHStarMap+;
@@ -27,5 +25,4 @@
 #pragma link C++ class MHThetabarTheta+;
 #pragma link C++ class MHSigmabarTheta+;
-#pragma link C++ class MHSigmaTheta+;
 #pragma link C++ class MHSigmaPixel+;
 #pragma link C++ class MHOnSubtraction+;
Index: trunk/MagicSoft/Mars/mhist/MHBlindPixels.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHBlindPixels.cc	(revision 4430)
+++ 	(revision )
@@ -1,204 +1,0 @@
-
-/* ======================================================================== *\
-!
-! *
-! * This file is part of MARS, the MAGIC Analysis and Reconstruction
-! * Software. It is distributed to you in the hope that it can be a useful
-! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
-! * It is distributed WITHOUT ANY WARRANTY.
-! *
-! * Permission to use, copy, modify and distribute this software and its
-! * documentation for any purpose is hereby granted without fee,
-! * provided that the above copyright notice appear in all copies and
-! * that both that copyright notice and this permission notice appear
-! * in supporting documentation. It is provided "as is" without express
-! * or implied warranty.
-! *
-!
-!
-!   Author(s): Thomas Bretz 04/2003 <mailto:tbretz@astro.uni-wuerzburg.de>
-!
-!   Copyright: MAGIC Software Development, 2000-2003
-!
-!
-\* ======================================================================== */
-
-/////////////////////////////////////////////////////////////////////////////
-//
-//  MHBlindPixels
-//
-////////////////////////////////////////////////////////////////////////////
-#include "MHBlindPixels.h" 
-
-#include <TCanvas.h>
-
-#include "MMcEvt.hxx"
-#include "MBlindPixels.h"
-#include "MGeomCam.h"
-#include "MPedPhotCam.h"
-#include "MParList.h"
-#include "MBinning.h"
-
-#include "MLog.h"
-#include "MLogManip.h"
-
-ClassImp(MHBlindPixels);
-
-using namespace std;
-
-// -------------------------------------------------------------------------
-//
-//  Default Constructor.
-//
-MHBlindPixels::MHBlindPixels(const char *name, const char *title)
-{
-    fName  = name  ? name  : "MHBlindPixels";
-    fTitle = title ? title : "Histogram for Blind Pixels vs. Theta";
-
-    //  - we initialize the histogram
-    //  - we have to give different names for the different histograms because
-    //    root don't allow us to have diferent histograms with the same name
-
-    fBlindId.SetName("2D-IdBlindPixels");
-    fBlindId.SetTitle("2D-IdBlindPixels");
-    fBlindId.SetDirectory(NULL);
-    fBlindId.SetXTitle("\\Theta [\\circ]");
-    fBlindId.SetYTitle("pixel Id");
-
-    fBlindN.SetName("2D-NBlindPixels");
-    fBlindN.SetTitle("2D-NBlindPixels");
-    fBlindN.SetDirectory(NULL);
-    fBlindN.SetXTitle("\\Theta [\\circ]");
-    fBlindN.SetYTitle("number of blind pixels");
-}
-
-// --------------------------------------------------------------------------
-//
-// Set the binnings and prepare the filling of the histogram
-//
-Bool_t MHBlindPixels::SetupFill(const MParList *plist)
-{
-    MGeomCam *fCam = (MGeomCam*)plist->FindObject(AddSerialNumber("MGeomCam"));
-    if (!fCam)    
-    {
-        *fLog << err << "MHBlindPixels::SetupFill; MGeomCam not found... aborting." << endl;
-        return kFALSE;
-    }
-
-    fMcEvt = (MMcEvt*)plist->FindObject("MMcEvt");
-    if (!fMcEvt)
-    {
-        *fLog << err << "MMcEvt not found... aborting." << endl;
-        return kFALSE;
-    }
-
-    
-    fPedPhot = (MPedPhotCam*)plist->FindObject("MPedPhotCam");
-    if (!fPedPhot)
-    {
-        *fLog << err << "MPedPhotCam not found... aborting." << endl;
-        return kFALSE;
-    }
-    fPedPhot->InitSize(fCam->GetNumPixels());
-    
-
-    // Get Theta Binning
-    MBinning* binstheta  = (MBinning*)plist->FindObject("BinningTheta", "MBinning");
-    if (!binstheta)
-    {
-        *fLog << err << "Object 'BinningTheta' [MBinning] not found... aborting" << endl;
-        return kFALSE;
-    }
-
-    // Get binning for pixel number
-    const UInt_t npix1 = fPedPhot->GetSize()+1;
-
-    MBinning binspix("BinningPixel");
-    binspix.SetEdges(npix1, -0.5, npix1-0.5);
-
-    // Set binnings in histograms
-    SetBinning(&fBlindId, binstheta, &binspix);
-    SetBinning(&fBlindN,  binstheta, &binspix);
-
-    return kTRUE;
-}
-
-// ------------------------------------------------------------------------
-// 
-// Drawing function. It creates its own canvas.
-//
-void MHBlindPixels::Draw(Option_t *option)
-{
-    TVirtualPad *pad = gPad ? gPad : MakeDefCanvas(this);
-    pad->SetBorderMode(0);
-
-    pad->Divide(2,2);
-
-    TH1D *h;
-
-    pad->cd(1);
-    fBlindId.Draw(option);
-
-    pad->cd(2);
-    fBlindN.Draw(option);
-
-    pad->cd(3);
-    gPad->SetBorderMode(0);
-    h = ((TH2*)&fBlindId)->ProjectionY("ProjY-pixId", -1, 9999, "");
-    h->SetDirectory(NULL);
-    h->SetTitle("Distribution of blind pixel Id");
-    h->SetXTitle("Id of blind pixel");
-    h->SetYTitle("No. of events");
-    h->Draw(option);
-    h->SetBit(kCanDelete);
-
-    pad->cd(4);
-    gPad->SetBorderMode(0);
-    h = ((TH2*)&fBlindN)->ProjectionY("ProjY-pixN", -1, 9999, "");
-    h->SetDirectory(NULL);
-    h->SetTitle("Distribution of no.of blind pixels");
-    h->SetXTitle("No. of blind pixels");
-    h->SetYTitle("No. of events");
-    h->Draw(option);
-    h->SetBit(kCanDelete);
-
-    pad->Modified();
-    pad->Update();
-}
-
-Bool_t MHBlindPixels::Fill(const MParContainer *par, const Stat_t w)
-{
-    if (!par)
-        return kFALSE;
-
-    Double_t theta = fMcEvt->GetTelescopeTheta()*kRad2Deg;
-    const MBlindPixels &bp = *(MBlindPixels*)par;
-
-    // FIXME: Slow.
-    const UInt_t npix = fPedPhot->GetSize();
-
-    UInt_t nb = 0;
-    for (UInt_t i=0; i<npix; i++)
-    {
-        if (bp.IsBlind(i))
-	{
-          fBlindId.Fill(theta, i, w);
-          nb++;
-	}   
-    }
-    fBlindN.Fill(theta, nb, w);
-
-    return kTRUE;
-}
-
-
-
-
-
-
-
-
-
-
-
-
Index: trunk/MagicSoft/Mars/mhist/MHBlindPixels.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHBlindPixels.h	(revision 4430)
+++ 	(revision )
@@ -1,47 +1,0 @@
-#ifndef MARS_MHBlindPixels
-#define MARS_MHBlindPixels
-
-#ifndef MARS_MH
-#include "MH.h"
-#endif
-#ifndef ROOT_TH2
-#include <TH2.h>
-#endif
-
-class MPedPhotCam;
-class MMcEvt;
-class MParList;
-class MGeomCam;
-
-class MHBlindPixels : public MH
-{
-private:
-    MGeomCam      *fCam;      //!
-    MPedPhotCam   *fPedPhot;  //!
-    MMcEvt        *fMcEvt;    //!
-
-    TH2D          fBlindId; // 2D-histogram : pixel Id vs. Theta
-    TH2D          fBlindN;  // 2D-histogram : no.of blind pixels vs. Theta
-
-public:
-    MHBlindPixels(const char *name=NULL, const char *title=NULL);
-
-    const TH2D *GetBlindId()       { return &fBlindId; }
-    const TH2D *GetBlindId() const { return &fBlindId; }
-
-    const TH2D *GetBlindN()       { return &fBlindN; }
-    const TH2D *GetBlindN() const { return &fBlindN; }
-
-    TH2 *GetBlinIdByName(const TString name) { return &fBlindId; }
-    TH2 *GetBlinNByName(const TString name) { return &fBlindN; }
-
-    void Draw(Option_t* option = "");
-    Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par, const Stat_t w=1);
-
-    ClassDef(MHBlindPixels, 1)  // Histogram of blind pixel Id vs. Theta
-};
-
-#endif
-
-
Index: trunk/MagicSoft/Mars/mhist/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mhist/Makefile	(revision 4430)
+++ trunk/MagicSoft/Mars/mhist/Makefile	(revision 4463)
@@ -25,4 +25,5 @@
 
 SRCFILES = MHEvent.cc \
+	   MHAlpha.cc \
            MHCamEvent.cc \
            MHCamEventRot.cc \
@@ -30,9 +31,9 @@
            MHFadcCam.cc \
            MHStarMap.cc \
+           MHFalseSource.cc \
            MHEnergyTime.cc \
            MHEnergyTheta.cc \
            MHAlphaEnergyTime.cc \
            MHAlphaEnergyTheta.cc \
-           MHBlindPixels.cc \
            MHEffOnTime.cc \
            MHTimeDiffTime.cc \
@@ -43,10 +44,7 @@
            MHThetabarTheta.cc \
            MHGamma.cc \
-           MHFalseSource.cc \
            MHFlux.cc \
-           MHAlpha.cc \
 	   MHSigmaPixel.cc \
 	   MHSigmabarTheta.cc \
-	   MHSigmaTheta.cc \
 	   MHTriggerLvl0.cc \
 	   MHOnSubtraction.cc \