Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4601)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4604)
@@ -5,6 +5,6 @@
 #include "MCalibrationChargeCam.h"
 #endif
-#ifndef MARS_MCalibrationChargeBlindPix
-#include "MCalibrationChargeBlindPix.h"
+#ifndef MARS_MCalibrationChargeBlindCam
+#include "MCalibrationChargeBlindCam.h"
 #endif
 #ifndef MARS_MCalibrationChargePINDiode
@@ -30,31 +30,33 @@
 private:
 
-  static const Int_t gkIFAEBoxInaugurationRun;              // Run number of first IFAE box calibration
+  static const Int_t gkIFAEBoxInaugurationRun;          // Run number of first IFAE box calibration
+  static const Int_t gkSecondBlindPixelInstallation;    // Run number upon which second blind pixel was installed
+  static const Int_t gkThirdBlindPixelInstallation;     // Run number upon which third blind pixel was installed  
 
-  TString fOutputPath;                                     // Path to the output files
+  TString fOutputPath;                                 // Path to the output files
   
-  MRunIter       *fRuns;                                   // Calibration files
-  MExtractor     *fExtractor;                              // Signal extractor
-  MExtractTime   *fTimeExtractor;                          // Arrival Time extractor
+  MRunIter       *fRuns;                               // Calibration files
+  MExtractor     *fExtractor;                          // Signal extractor
+  MExtractTime   *fTimeExtractor;                      // Arrival Time extractor
   
-  MBadPixelsCam              fBadPixels;                   // Bad Pixels cam, can be set from previous runs
-  MCalibrationChargeCam      fCalibrationCam;              // Calibration conversion factors FADC2Phe
-  MCalibrationChargeBlindPix fCalibrationBlindPix;         // Calibration from Blind Pixel
-  MCalibrationChargePINDiode fCalibrationPINDiode;         // Calibration from PIN Diode
-  MCalibrationQECam          fQECam;                       // Quantum efficiency, can be set from previous runs
-  MCalibrationRelTimeCam     fRelTimeCam;                  // Calibration constants rel. times
+  MBadPixelsCam              fBadPixels;               // Bad Pixels cam, can be set from previous runs
+  MCalibrationChargeCam      fCalibrationCam;          // Calibration conversion factors FADC2Phe
+  MCalibrationChargeBlindCam fCalibrationBlindCam;     // Calibration from Blind Pixel(s)
+  MCalibrationChargePINDiode fCalibrationPINDiode;     // Calibration from PIN Diode
+  MCalibrationQECam          fQECam;                   // Quantum efficiency, can be set from previous runs
+  MCalibrationRelTimeCam     fRelTimeCam;              // Calibration constants rel. times
 
-  MCalibrationCam::PulserColor_t fColor;                   // Colour of the pulsed LEDs
+  MCalibrationCam::PulserColor_t fColor;               // Colour of the pulsed LEDs
 
   enum  Display_t   { kFullDisplay, kDataCheckDisplay, kNormalDisplay }; // Possible Display types
   
-  Display_t fDisplayType;                                  // Chosen Display type
+  Display_t fDisplayType;                              // Chosen Display type
 
-  enum  Device_t    { kUseBlindPixel, kUsePINDiode  };     // Possible devices for calibration
+  enum  Device_t    { kUseBlindPixel, kUsePINDiode  }; // Possible devices for calibration
 
-  Byte_t fDevices;                                         // Bit-field for used devices for calibration
+  Byte_t fDevices;                                     // Bit-field for used devices for calibration
   
-  Bool_t fRelTimes;                                        // Flag if relative times have to be calibrated
-  Bool_t fDataCheck;                                       // Flag if the data check is run on raw data
+  Bool_t fRelTimes;                                    // Flag if relative times have to be calibrated
+  Bool_t fDataCheck;                                   // Flag if the data check is run on raw data
   Bool_t fDebug;
 
@@ -91,5 +93,5 @@
   void SetDataCheckDisplay() { fDisplayType = kDataCheckDisplay; }
   void SetNormalDisplay()    { fDisplayType = kNormalDisplay;    }
-
+  
   // Rel. Time
   void SetRelTimeCalibration(const Bool_t b=kTRUE) { fRelTimes         = b; }