Index: trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 4608)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 4609)
@@ -1524,7 +1524,8 @@
         }
 
-      *fLog << inf << GetDescriptor() << ": Mean overall F-Factor (photons to FADC counts) " 
-            << "with area index: " << i << ": " 
-            << Form("%4.2f+-%4.2f",mean,sigma) << endl;
+      *fLog << inf << endl;
+      *fLog << inf << GetDescriptor() << ": Mean F-Factor " 
+          << "with area index #" << i << ": "
+            << Form("%4.2f+-%4.2f",mean,sigma) << "fadc/ph" << endl;
 
       lowlim  [i] = 1.1;
@@ -1550,7 +1551,8 @@
       if ( ffactor < lowlim[aidx] || ffactor > upplim[aidx] )
         {
-          *fLog << warn << GetDescriptor() << ": Overall F-Factor: " 
-                << Form("%5.2f out of %3.1f sigma limit: ",ffactor,fFFactorErrLimit)
-                << Form("[%5.2f,%5.2f] pixel %4i",lowlim[aidx],upplim[aidx],i) << endl;
+          *fLog << warn << GetDescriptor() << ": Overall F-Factor "
+                << Form("%5.2f",ffactor) << " out of range ["
+                << Form("%5.2f,%5.2f",lowlim[aidx],upplim[aidx]) << "] pixel " << i << endl;
+
           bad.SetUncalibrated( MBadPixelsPix::kDeviatingFFactor );
           bad.SetUnsuitable  ( MBadPixelsPix::kUnsuitableRun    );
@@ -1857,2 +1859,52 @@
   return Form("%s/%s", (const char*)fOutputPath, (const char*)fOutputFile);
 }
+
+Int_t MCalibrationChargeCalc::ReadEnv(const TEnv &env, TString prefix, Bool_t print)
+{
+    Bool_t rc = kFALSE;
+    if (IsEnvDefined(env, prefix, "ChargeLimit", print))
+    {
+        SetChargeLimit(GetEnvValue(env, prefix, "ChargeLimit", fChargeLimit));
+        rc = kTRUE;
+    }
+
+    if (IsEnvDefined(env, prefix, "ChargeErrLimit", print))
+    {
+        SetChargeErrLimit(GetEnvValue(env, prefix, "ChargeErrLimit", fChargeErrLimit));
+        rc = kTRUE;
+    }
+
+    if (IsEnvDefined(env, prefix, "ChargeRelErrLimit", print))
+    {
+        SetChargeRelErrLimit(GetEnvValue(env, prefix, "ChargeRelErrLimit", fChargeRelErrLimit));
+        rc = kTRUE;
+    }
+    if (IsEnvDefined(env, prefix, "Debug", print))
+    {
+        SetDebug(GetEnvValue(env, prefix, "Debug", IsDebug()));
+        rc = kTRUE;
+    }
+    if (IsEnvDefined(env, prefix, "FFactorErrLimit", print))
+    {
+        SetFFactorErrLimit(GetEnvValue(env, prefix, "FFactorErrLimit", fFFactorErrLimit));
+        rc = kTRUE;
+    }
+    if (IsEnvDefined(env, prefix, "LambdaErrLimit", print))
+    {
+        SetLambdaErrLimit(GetEnvValue(env, prefix, "LambdaErrLimit", fLambdaErrLimit));
+        rc = kTRUE;
+    }
+    if (IsEnvDefined(env, prefix, "LambdaCheckLimit", print))
+    {
+        SetLambdaCheckLimit(GetEnvValue(env, prefix, "LambdaCheckLimit", fLambdaCheckLimit));
+        rc = kTRUE;
+    }
+    if (IsEnvDefined(env, prefix, "PheErrLimit", print))
+    {
+        SetPheErrLimit(GetEnvValue(env, prefix, "PheErrLimit", fPheErrLimit));
+        rc = kTRUE;
+    }
+    // void SetPulserColor(const MCalibrationCam::PulserColor_t col) { fPulserColor = col; }
+
+    return rc;
+}
Index: trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.h
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.h	(revision 4608)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.h	(revision 4609)
@@ -127,4 +127,5 @@
   Int_t  Process    ();
   Int_t  PostProcess();
+  Int_t  ReadEnv(const TEnv &env, TString prefix, Bool_t print);
 
 public:
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc	(revision 4608)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc	(revision 4609)
@@ -1023,2 +1023,13 @@
 }
 
+Int_t MHCalibrationCam::ReadEnv(const TEnv &env, TString prefix, Bool_t print)
+{
+    Bool_t rc = kFALSE;
+    if (IsEnvDefined(env, prefix, "Debug", print))
+    {
+        SetDebug(GetEnvValue(env, prefix, "Debug", IsDebug()));
+        rc = kTRUE;
+    }
+
+    return rc;
+}
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.h
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.h	(revision 4608)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.h	(revision 4609)
@@ -109,4 +109,6 @@
   void InitHists(MHGausEvents &hist, MBadPixelsPix &bad, const Int_t i);
 
+  Int_t ReadEnv(const TEnv &env, TString prefix, Bool_t print);
+
 public:
 