Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 4613)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 4616)
@@ -77,8 +77,10 @@
 const Float_t  MJPedestal::fgRefPedExtraGalactic    = 9.93;
 const Float_t  MJPedestal::fgRefPedGalactic         = 10.03;
-const Float_t  MJPedestal::fgRefPedRmsClosedLids    = 1.7;
-const Float_t  MJPedestal::fgRefPedRmsExtraGalactic = 5.6;
-const Float_t  MJPedestal::fgRefPedRmsGalactic      = 6.92;
-
+const Float_t  MJPedestal::fgRefPedRmsClosedLidsInner    = 1.7;
+const Float_t  MJPedestal::fgRefPedRmsExtraGalacticInner = 5.6;
+const Float_t  MJPedestal::fgRefPedRmsGalacticInner      = 6.92;
+const Float_t  MJPedestal::fgRefPedRmsClosedLidsOuter    = 1.7;
+const Float_t  MJPedestal::fgRefPedRmsExtraGalacticOuter = 3.35;
+const Float_t  MJPedestal::fgRefPedRmsGalacticOuter      = 4.2;
 // --------------------------------------------------------------------------
 //
@@ -183,6 +185,6 @@
     disp1.SetCamError  (fPedestalCam, 3);
 
-    disp0.SetYTitle("P [fadc/slice]");
-    disp1.SetYTitle("\\sigma_{P} [fadc/slice]");
+    disp0.SetYTitle("Pedestal [counts/slice]");
+    disp1.SetYTitle("RMS [counts/slice]");
 
     //
@@ -203,6 +205,4 @@
     gPad->SetTicks();
     MHCamera *obj1=(MHCamera*)disp0.DrawCopy("hist");
-    obj1->SetDirectory(NULL);
-
     //
     // for the datacheck, fix the ranges!!
@@ -211,4 +211,8 @@
     obj1->SetMaximum(fgPedestalMax);
 
+    //
+    // Set the datacheck sizes:
+    //
+    FixDataCheckHist((TH1D*)obj1);
     //
     // set reference lines
@@ -227,14 +231,28 @@
     gPad->SetBorderMode(0);
     gPad->SetTicks();
-    obj1->DrawProjection(7);
+    TH1D *obj2 = (TH1D*)obj1->Projection(obj1->GetName());
+    obj2->Draw();
+    obj2->SetBit(kCanDelete);
+    obj2->Fit("gaus","Q");
+    obj2->GetFunction("gaus")->SetLineColor(kYellow);
+    //
+    // Set the datacheck sizes:
+    //
+    FixDataCheckHist(obj2);
+    obj2->SetStats(1);
 
     c3.cd(2);
     gPad->SetBorderMode(0);
     gPad->SetTicks();
-    MHCamera *obj2=(MHCamera*)disp1.DrawCopy("hist");
-    obj2->SetDirectory(NULL);
-    obj2->SetMinimum(fgPedRmsMin);
-    obj2->SetMaximum(fgPedRmsMax);
-
+    MHCamera *obj3=(MHCamera*)disp1.DrawCopy("hist");
+    //
+    // for the datacheck, fix the ranges!!
+    //
+    obj3->SetMinimum(fgPedRmsMin);
+    obj3->SetMaximum(fgPedRmsMax);
+    //
+    // Set the datacheck sizes:
+    //
+    FixDataCheckHist((TH1D*)obj3);
     //
     // set reference lines
@@ -244,6 +262,6 @@
     c3.cd(4);
     gPad->SetBorderMode(0);
-    obj2->SetPrettyPalette();
-    obj2->Draw();
+    obj3->SetPrettyPalette();
+    obj3->Draw();
 
     c3.cd(6);
@@ -282,4 +300,10 @@
         inout[0] = disp1.ProjectionS(s0, inner, "Inner");
         inout[1] = disp1.ProjectionS(s0, outer, "Outer");
+        FixDataCheckHist(inout[0]);
+        FixDataCheckHist(inout[1]);
+
+        inout[0]->SetTitle(Form("%s %s",disp1.GetTitle(),"Inner"));
+        inout[1]->SetTitle(Form("%s %s",disp1.GetTitle(),"Outer"));
+        
 
         for (int i=0; i<2; i++)
@@ -326,29 +350,53 @@
 void  MJPedestal::DisplayReferenceLines(MHCamera *cam, const Int_t what) const
 {
-    const Double_t x = cam->GetNbinsX();
-
-    TLine line;
-    line.SetLineStyle(kDashed);
-    line.SetLineWidth(3);
+
+  Double_t x = cam->GetNbinsX();
+  
+  const MGeomCam *geom = cam->GetGeometry();
+
+  if (geom->InheritsFrom("MGeomCamMagic"))
+    x = what ? 397 : cam->GetNbinsX();
+
+  TLine line;
+  line.SetLineStyle(kDashed);
+  line.SetLineWidth(3);
+  
+  line.SetLineColor(kBlue);
+  TLine *l1 = line.DrawLine(0, what ? fgRefPedRmsGalacticInner : fgRefPedGalactic,
+                            x, what ? fgRefPedRmsGalacticInner : fgRefPedGalactic);
+  
+  line.SetLineColor(kYellow);
+  TLine *l2 = line.DrawLine(0, what ? fgRefPedRmsExtraGalacticInner : fgRefPedExtraGalactic,
+                            x, what ? fgRefPedRmsExtraGalacticInner : fgRefPedExtraGalactic);
+  
+  line.SetLineColor(kMagenta);
+  TLine *l3 = line.DrawLine(0, what ? fgRefPedRmsClosedLidsInner : fgRefPedClosedLids,
+                            x, what ? fgRefPedRmsClosedLidsInner : fgRefPedClosedLids);
+  
+  if (geom->InheritsFrom("MGeomCamMagic"))
+    if (what)
+      {
+        const Double_t x2 = cam->GetNbinsX();
+
+        line.SetLineColor(kBlue);
+        line.DrawLine(398, fgRefPedRmsGalacticOuter,
+                      x2,  fgRefPedRmsGalacticOuter);
+        
+        line.SetLineColor(kYellow);
+        line.DrawLine(398, fgRefPedRmsExtraGalacticOuter,
+                      x2,  fgRefPedRmsExtraGalacticOuter);
+        
+        line.SetLineColor(kMagenta);
+        line.DrawLine(398, fgRefPedRmsClosedLidsOuter,
+                      x2,  fgRefPedRmsClosedLidsOuter);
+      }
+  
     
-    line.SetLineColor(kBlue);
-    TLine *l1 = line.DrawLine(0, what ? fgRefPedRmsGalactic : fgRefPedGalactic,
-                              x, what ? fgRefPedRmsGalactic : fgRefPedGalactic);
-
-    line.SetLineColor(kYellow);
-    TLine *l2 = line.DrawLine(0, what ? fgRefPedRmsExtraGalactic : fgRefPedExtraGalactic,
-                              x, what ? fgRefPedRmsExtraGalactic : fgRefPedExtraGalactic);
-
-    line.SetLineColor(kMagenta);
-    TLine *l3 = line.DrawLine(0, what ? fgRefPedRmsClosedLids : fgRefPedClosedLids,
-                              x, what ? fgRefPedRmsClosedLids : fgRefPedClosedLids);
-
-    
-    TLegend *leg = new TLegend(0.4,0.75,0.7,0.99);
-    leg->SetBit(kCanDelete);
-    leg->AddEntry(l1, "Galactic Source","l");
-    leg->AddEntry(l2, "Extra-Galactic Source","l");
-    leg->AddEntry(l3, "Closed Lids","l");
-    leg->Draw();
+  TLegend *leg = new TLegend(0.4,0.75,0.7,0.99);
+  leg->SetBit(kCanDelete);
+  leg->AddEntry(l1, "Galactic Source","l");
+  leg->AddEntry(l2, "Extra-Galactic Source","l");
+  leg->AddEntry(l3, "Closed Lids","l");
+  leg->Draw();
 }
 
@@ -369,4 +417,28 @@
     noisytex.DrawLatex(0.1,hist->GetBinContent(hist->GetMaximumBin())/1.2,Form("%3i noisy pixels",(Int_t)noisy));
 }
+
+void MJPedestal::FixDataCheckHist(TH1D *hist) const 
+{
+
+    hist->SetDirectory(NULL);
+    hist->SetStats(0);
+
+    //
+    // set the labels bigger
+    //
+    TAxis *xaxe = hist->GetXaxis();
+    TAxis *yaxe = hist->GetYaxis();
+    
+    xaxe->CenterTitle();
+    yaxe->CenterTitle();    
+    xaxe->SetTitleSize(0.06);
+    yaxe->SetTitleSize(0.06);    
+    xaxe->SetTitleOffset(0.8);
+    yaxe->SetTitleOffset(0.5);    
+    xaxe->SetLabelSize(0.05);
+    yaxe->SetLabelSize(0.05);    
+
+}
+
 
 Bool_t MJPedestal::WriteResult()
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.h	(revision 4613)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.h	(revision 4616)
@@ -30,8 +30,12 @@
     static const Float_t  fgRefPedGalactic;
 
-    static const Float_t  fgRefPedRmsClosedLids;
-    static const Float_t  fgRefPedRmsExtraGalactic;
-    static const Float_t  fgRefPedRmsGalactic;
+    static const Float_t  fgRefPedRmsClosedLidsInner;
+    static const Float_t  fgRefPedRmsExtraGalacticInner;
+    static const Float_t  fgRefPedRmsGalacticInner;
 
+    static const Float_t  fgRefPedRmsClosedLidsOuter;
+    static const Float_t  fgRefPedRmsExtraGalacticOuter;
+    static const Float_t  fgRefPedRmsGalacticOuter;
+    
     TString fOutputPath;
 
@@ -57,5 +61,6 @@
     void   DisplayReferenceLines(MHCamera *cam, const Int_t what) const;
     void   DisplayOutliers(TH1D *hist) const;
-
+    void   FixDataCheckHist(TH1D *hist) const;
+    
     void   CheckEnv();
 