Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4623)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 4626)
@@ -156,4 +156,18 @@
 const Int_t MJCalibration::gkSecondBlindPixelInstallation = 31693;
 const Int_t MJCalibration::gkThirdBlindPixelInstallation  = 99999;
+
+const Double_t MJCalibration::fgConvFADC2PheMin           = 0.;
+const Double_t MJCalibration::fgConvFADC2PheMax           = 1.5;
+const Double_t MJCalibration::fgConvFADC2PhotMin          = 0.; 
+const Double_t MJCalibration::fgConvFADC2PhotMax          = 10.; 
+const Double_t MJCalibration::fgQEMin                     = 0.;
+const Double_t MJCalibration::fgQEMax                     = 0.3;
+
+const Float_t  MJCalibration::fgRefConvFADC2PheInner      = 0.14;       
+const Float_t  MJCalibration::fgRefConvFADC2PheOuter      = 0.45;       
+const Float_t  MJCalibration::fgRefConvFADC2PhotInner     = 0.8; 
+const Float_t  MJCalibration::fgRefConvFADC2PhotOuter     = 3.8; 
+const Float_t  MJCalibration::fgRefQEInner                = 0.18;            
+const Float_t  MJCalibration::fgRefQEOuter                = 0.12;
 // --------------------------------------------------------------------------
 //
@@ -559,6 +573,6 @@
       // for the datacheck, fix the ranges!!
       //
-      // obj5->SetMinimum(fgChargeMin);
-      // obj5->SetMaximum(fgChargeMax);
+      obj5->SetMinimum(fgConvFADC2PheMin);
+      obj5->SetMaximum(fgConvFADC2PheMax);
       //
       // Set the datacheck sizes:
@@ -568,5 +582,5 @@
       // set reference lines
       //
-      //        DisplayReferenceLines(obj5,0);
+      DisplayReferenceLines(obj5,2);
       
       c2.cd(4);
@@ -591,6 +605,6 @@
       // for the datacheck, fix the ranges!!
       //
-      // obj6->SetMinimum(fgChargeMin);
-      // obj6->SetMaximum(fgChargeMax);
+      obj6->SetMinimum(fgQEMin);
+      obj6->SetMaximum(fgQEMax);
       //
       // Set the datacheck sizes:
@@ -600,5 +614,5 @@
       // set reference lines
       //
-      //        DisplayReferenceLines(obj6,0);
+      DisplayReferenceLines(obj6,0);
       
       c2.cd(5);
@@ -623,6 +637,6 @@
       // for the datacheck, fix the ranges!!
       //
-      // obj3->SetMinimum(fgChargeMin);
-      // obj3->SetMaximum(fgChargeMax);
+      obj7->SetMinimum(fgConvFADC2PhotMin);
+      obj7->SetMaximum(fgConvFADC2PhotMax);
       //
       // Set the datacheck sizes:
@@ -632,5 +646,5 @@
       // set reference lines
       //
-      //        DisplayReferenceLines(obj3,0);
+      DisplayReferenceLines(obj7,1);
       
       c2.cd(6);
@@ -855,55 +869,44 @@
 {
 
-  Double_t x = cam->GetNbinsX();
-  
   const MGeomCam *geom = cam->GetGeometry();
 
-  if (geom->InheritsFrom("MGeomCamMagic"))
-    x = what ? 397 : cam->GetNbinsX();
+  Double_t x = geom->InheritsFrom("MGeomCamMagic") ? 397 : cam->GetNbinsX() ;
 
   TLine line;
   line.SetLineStyle(kDashed);
   line.SetLineWidth(3);
-  
-  /*
   line.SetLineColor(kBlue);
-  TLine *l1 = line.DrawLine(0, what ? fgRefPedRmsGalacticInner : fgRefPedGalactic,
-                            x, what ? fgRefPedRmsGalacticInner : fgRefPedGalactic);
-  
-  line.SetLineColor(kYellow);
-  TLine *l2 = line.DrawLine(0, what ? fgRefPedRmsExtraGalacticInner : fgRefPedExtraGalactic,
-                            x, what ? fgRefPedRmsExtraGalacticInner : fgRefPedExtraGalactic);
-  
-  line.SetLineColor(kMagenta);
-  TLine *l3 = line.DrawLine(0, what ? fgRefPedRmsClosedLidsInner : fgRefPedClosedLids,
-                            x, what ? fgRefPedRmsClosedLidsInner : fgRefPedClosedLids);
-
+  
+  TLine *l1 = NULL;
+
+  if (what == 0)
+    l1 = line.DrawLine(0, fgRefQEInner, x, fgRefQEInner);      
+  else if (what == 1)
+    l1 = line.DrawLine(0, fgRefConvFADC2PhotInner, x, fgRefConvFADC2PhotInner);      
+  else if (what == 2)
+    l1 = line.DrawLine(0, fgRefConvFADC2PheInner, x, fgRefConvFADC2PheInner );
+  
   if (geom->InheritsFrom("MGeomCamMagic"))
-    if (what)
-      {
-        const Double_t x2 = cam->GetNbinsX();
-
-        line.SetLineColor(kBlue);
-        line.DrawLine(398, fgRefPedRmsGalacticOuter,
-                      x2,  fgRefPedRmsGalacticOuter);
-        
-        line.SetLineColor(kYellow);
-        line.DrawLine(398, fgRefPedRmsExtraGalacticOuter,
-                      x2,  fgRefPedRmsExtraGalacticOuter);
-        
-        line.SetLineColor(kMagenta);
-        line.DrawLine(398, fgRefPedRmsClosedLidsOuter,
-                      x2,  fgRefPedRmsClosedLidsOuter);
-      }
-    
-  TLegend *leg = new TLegend(0.4,0.75,0.7,0.99);
+    {
+      const Double_t x2 = cam->GetNbinsX();
+
+      switch (what)
+        {
+        case 0:
+          line.DrawLine(x2, fgRefQEOuter, 398, fgRefQEOuter);      
+          break;
+        case 1:
+          line.DrawLine(x2, fgRefConvFADC2PhotOuter, 398, fgRefConvFADC2PhotOuter );      
+          break;
+        case 2:
+          line.DrawLine(x2, fgRefConvFADC2PheOuter, 398, fgRefConvFADC2PheOuter);
+          break;
+        }
+    }
+  
+  TLegend *leg = new TLegend(what ? 0.2 : 0.6,0.75,what ? 0.5 : 0.9 ,0.85);
   leg->SetBit(kCanDelete);
-  leg->AddEntry(l1, "Galactic Source","l");
-  leg->AddEntry(l2, "Extra-Galactic Source","l");
-  leg->AddEntry(l3, "Closed Lids","l");
+  leg->AddEntry(l1, "Reference","l");
   leg->Draw();
-  */    
-
-
 }
 
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4623)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.h	(revision 4626)
@@ -41,4 +41,11 @@
   static const Int_t gkThirdBlindPixelInstallation;    //! Run number upon which third blind pixel was installed
 
+  static const Double_t fgConvFADC2PheMin;             //! Histogram minimum for conversion factor to phes
+  static const Double_t fgConvFADC2PheMax;             //! Histogram maximum for conversion factor to phes
+  static const Double_t fgConvFADC2PhotMin;            //! Histogram minimum for conversion factor to phs
+  static const Double_t fgConvFADC2PhotMax;            //! Histogram maixmum for conversion factor to phs
+  static const Double_t fgQEMin;                       //! Histogram minimum for quantum efficiency
+  static const Double_t fgQEMax;                       //! Histogram maximum for quantum efficiency
+  
   static const Float_t  fgRefConvFADC2PheInner;        //! Reference value for the conversion factor to phes - inner
   static const Float_t  fgRefConvFADC2PheOuter;        //! Reference value for the conversion factor to phes - outer